Attribute VB_Name = "basMain"
Option Explicit

Public Const MAX_PATH = 260
Public Const WM_USER As Long = &H400

Public Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As NOTIFYICONDATA) As Boolean
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function SearchLB Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SendMessageB Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Integer, ByVal lParam As Any) As Long
Public Declare Function FindWindowA Lib "user32" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function IsWindowVisibleA Lib "user32" Alias "IsWindowVisible" (ByVal hWnd As Long) As Long

Public Declare Sub SetLastError Lib "kernel32" (ByVal dwErrCode As Long)

Private Declare Sub SleepA Lib "kernel32" Alias "Sleep" (ByVal dwMilliseconds As Long)

Private Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Any) As Long
Private Declare Function SendMessageByString Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hWnd As Long, lpdwProcessId As Long) As Long
Private Declare Function ClientToScreen Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal hWnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long
Private Declare Function OpenFile Lib "kernel32" (ByVal lpFileName As String, lpReOpenBuff As OFSTRUCT, ByVal wStyle As Long) As Long
Private Declare Function GetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Private Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpStrCommand As String, ByVal lpStrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallBack As Long) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Function PlaySound Lib "winmm.dll" (ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long
Public Declare Function GetWindowLongA Lib "user32.dll" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwnewLong As Long) As Long
Public Declare Function GetLastError Lib "kernel32" () As Long
Public Declare Function GetClientRect Lib "user32.dll" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function MakePath Lib "imagehlp.dll" Alias "MakeSureDirectoryPathExists" (ByVal lpPath As String) As Long
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function ChooseColor Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As LPCHOOSECOLOR) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function AnimateWindow Lib "user32" (ByVal hWnd As Long, ByVal dwTime As Long, ByVal dwFlags As Long) As Boolean
Private Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Public Declare Function SHFileOperation Lib "shell32.dll" Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long
Private Declare Function CreateToolhelpSnapshot Lib "kernel32" Alias "CreateToolhelp32Snapshot" (ByVal lFlgas As Long, ByVal lProcessID As Long) As Long
Private Declare Function ProcessFirst Lib "kernel32" Alias "Process32First" (ByVal hSnapshot As Long, uProcess As PROCESSENTRY32) As Long
Private Declare Function ProcessNext Lib "kernel32" Alias "Process32Next" (ByVal hSnapshot As Long, uProcess As PROCESSENTRY32) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessID As Long) As Long
Private Declare Function GetModuleFileNameExA Lib "psapi.dll" (ByVal hProcess As Long, ByVal hModule As Long, ByVal ModuleName As String, ByVal nSize As Long) As Long
Private Declare Function Process32First Lib "kernel32" (ByVal hSnapshot As Long, lppe As PROCESSENTRY32) As Long
Private Declare Function Process32Next Lib "kernel32" (ByVal hSnapshot As Long, lppe As PROCESSENTRY32) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Private Declare Sub SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hWnd As Long, ByVal CSIDL As Long, ByRef pPIDL As Long)
Private Declare Sub CoInitialize Lib "ole32.dll" (ByRef pvReserved As Any)
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)
Public Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long
Public Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Function GetClassName& Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long)
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Private Declare Function ILCreateFromPath Lib "shell32" Alias "#157" (ByVal sPath As String) As Long
Private Declare Function SendMessageByNum& Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

Private Const BFFM_INITIALIZED = 1
Private Const BFFM_SETSELECTIONA = (WM_USER + 102)
Private Const BFFM_SELCHANGED = 2
Private Const BFFM_SETSTATUSTEXTA = (WM_USER + 100)
Private Const BFFM_VALIDATEFAILEDA = 3

Public Enum FileOperationNFO
    foCOPY = 1
    foMOVE = 2
    foRENAME = 3
    foDELETE = 4
End Enum

Public Enum oS
    osUNKNOWN = 0
    osWindows32s = 1
    osWindows95 = 2
    osWindows98 = 3
    osWindows98SE = 4
    osWindowsNT35x = 5
    osWindowsNT40 = 6
    osWindowsMillenium = 7
    osWindows2000 = 8
    osWindowsXP = 9
    osWindows2003 = 10
    osWindowsNET = osWindows2003
End Enum

Private Const OFS_MAXPATHNAME As Long = 128&
Private Const OF_READ As Long = &H0&

Private Type ITEMID
    CB   As Long
    abID As Byte
End Type

Public Enum cCenterNFO
    ccTOP = 1
    ccMIDDLE = 2
    ccBOTTOM = 3
    ccHWND = 4
End Enum

Public Type SHFILEOPSTRUCT
    hWnd                  As Long
    wFunc                 As Long
    pFrom                 As String
    pTo                   As String
    fFlags                As Integer
    fAnyOperationsAborted As Boolean
    hNameMappings         As Long
    lpszProgressTitle     As String
End Type

Private Type OFSTRUCT
    cBytes As Byte
    fFixedDisk As Byte
    nErrCode As Integer
    Reserved1 As Integer
    Reserved2 As Integer
    szPathName(OFS_MAXPATHNAME) As Byte
End Type

Private Type OPENFILENAME
    lStructSize       As Long
    hWndOwner         As Long
    hInstance         As Long
    lpstrFilter       As String
    lpstrCustomFilter As String
    nMaxCustFilter    As Long
    nFilterIndex      As Long
    lpstrFile         As String
    nMaxFile          As Long
    lpstrFileTitle    As String
    nMaxFileTitle     As Long
    lpstrInitialDir   As String
    lpstrTitle        As String
    FLAGS             As Long
    nFileOffset       As Integer
    nFileExtension    As Integer
    lpstrDefExt       As String
    lCustData         As Long
    lpfnHook          As Long
    lpTemplateName    As String
End Type

Public Enum arADDTO
    arTOBEGIN = 1
    arTOEND = 2
    arADDTOINDEX = 3
End Enum

Private Type SYSTEMTIME
    wYear         As Integer
    wMonth        As Integer
    wDayOfWeek    As Integer
    wDay          As Integer
    wHour         As Integer
    wMinute       As Integer
    wSecond       As Integer
    wMilliseconds As Integer
End Type

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Type MyNFO
    Path        As String
    INI         As String
    Source      As String
    Destination As String
    Color       As Long
    Prefix      As String
    AllMB       As String
    AllFiles    As String
    H           As Long
    W           As Long
    Log         As String
    Name        As String
    Version     As String
    SoundFile   As String
    Task        As String
    CopyFile    As String
    Intervall   As Long
    TaskList    As String
End Type

Public Type NOTIFYICONDATA
    cbSize           As Long
    hWnd             As Long
    uId              As Long
    uFlags           As Long
    ucallbackMessage As Long
    hIcon            As Long
    szTip            As String * 64
End Type

Public Enum CISNFO
    cisGETCURSEL = 1
    cisSETCURSEL = 2
    cisINSERTSTRING = 3
    cisDELETESTRING = 4
    cisRESETCONTENT = 5
    cisFINDSTRINGEXACT = 6
    cisFINDSTRING = 7
    
    cisLB_SETSEL = 8
End Enum

Public Enum enum_ShellSpecialFolder
    SP_ALTSTARTUP = &H1D
    SP_APPDATA = &H1A
    SP_BITBUCKET = &HA
    SP_COMMONALTSTARTUP = &H1E
    SP_COMMONAPPDATA = &H23
    SP_COMMONDESKTOPDIR = &H19
    SP_COMMONFAVORITES = &H1F
    SP_COMMONPROGRAMS = &H17
    SP_COMMONSTARTMENU = &H16
    SP_COMMONSTARTUP = &H18
    SP_CONTROLS = &H3
    SP_COOKIES = &H21
    SP_DESKTOP = &H0
    SP_DESKTOPDIRECTORY = &H10
    SP_DRIVES = &H11
    SP_FAVORITES = &H6
    SP_FONTS = &H14
    SP_HISTORY = &H22
    SP_INTERNETCACHE = &H20
    SP_LOCALAPPDATA = &H1C
    SP_MYPICTURES = &H27
    SP_NETHOOD = &H13
    SP_NETWORK = &H12
    SP_PERSONAL = &H5
    SP_PRINTERS = &H4
    SP_PRINTHOOD = &H1B
    SP_PROFILE = &H28
    SP_PROGRAMFILES = &H26
    SP_PROGRAMS = &H2
    SP_RECENT = &H8
    SP_SENDTO = &H9
    SP_STARTMENU = &HB
    SP_STARTUP = &H7
    SP_SYSTEM = &H25
    SP_TEMPLATES = &H15
    SP_WINDOWS = &H24
End Enum

Public Enum ShellBrowseFlags
    BIF_RETURNONLYFSDIRS = &H1
    BIF_DONTGOBELOWDOMAIN = &H2
    BIF_STATUSTEXT = &H4
    BIF_RETURNFSANCESTORS = &H8
    BIF_EDITBOX = &H10
    BIF_VALIDATE = &H20
    BIF_USENEWUI = &H40
    BIF_NEWDIALOGSTYLE = &H40
    BIF_BROWSEINCLUDEURLS = &H80
    BIF_UAHINT = &H100
    BIF_NONEWFOLDERBUTTON = &H200
    BIF_NOTRANSLATETARGETS = &H400
    BIF_BROWSEFORCOMPUTER = &H1000
    BIF_BROWSEFORPRINTER = &H2000
    BIF_BROWSEINCLUDEFILES = &H4000
    BIF_SHAREABLE = &H8000
End Enum

Public Enum DirectoryOperationNFO
    doCOPY = 1
    doMOVE = 2
    doRENAME = 3
    doDELETE = 4
End Enum

Private Const CB_FINDSTRING = &H14C
Private Const CB_FINDSTRINGEXACT = &H158
Private Const CB_INSERTSTRING = &H14A
Private Const CB_GETCURSEL = &H147
Private Const CB_RESETCONTENT = &H14B
Public Const CB_DELETESTRING = &H144
Public Const CB_SETCURSEL = &H14E

Private Const LB_DELETESTRING = &H182
Private Const LB_INSERTSTRING = &H181
Private Const LB_FINDSTRING = &H18F
Private Const LB_GETCURSEL = &H188
Private Const LB_RESETCONTENT = &H184
Private Const LB_SETCURSEL = &H186
Private Const LB_SETSEL = &H185
Private Const LB_FINDSTRINGEXACT = &H1A2

Public Type RECT
    Left   As Long
    Top    As Long
    Right  As Long
    Bottom As Long
End Type

Public Enum ANIMETNFO
    anFADEIN = 0
    anLEFT_TO_RIGHT = 1
    anUPPERLEFT_TO_LOWERRIGHT = 2
    anRIGHT_TO_LEFT = 3
    anUPERRIGHT_TO_LOWERLEFT = 4
    anUP_TO_DOWN = 5
    anDOWN_TO_UP = 6
    anMIDDLE = 7
    anFADEOUT = 8
End Enum

Private Type LPCHOOSECOLOR
    lStructSize    As Long
    hWnd           As Long
    hInstance      As Long
    rgbResult      As Long
    lpCustColors   As String
    FLAGS          As Long
    lCustData      As Long
    lpfnHook       As Long
    lpTemplateName As String
End Type

Public Const WS_THICKFRAME = &H40000
Public Const WS_CAPTION = &HC00000
Public Const WS_VISIBLE = &H10000000
Public Const WS_MINIMIZE = &H20000000
Public Const WS_MAXIMIZEBOX = &H10000
Public Const WS_MINIMIZEBOX = &H20000
Public Const WS_SYSMENU = &H80000
Public Const WS_BORDER = &H800000
Public Const WS_EX_APPWINDOW = &H40000
Public Const WS_EX_RIGHT = &H1000
Public Const WS_POPUP = &H80000000
Public Const WS_EX_TOPMOST = &H8&
Private Const WS_SIZEBOX = &H40000
Public Const WM_GETTEXT = &HD
Public Const WM_GETTEXTLENGTH = &HE

Public Const NIM_ADD = &H0
Public Const NIM_MODIFY = &H1
Public Const NIM_DELETE = &H2
Public Const WM_MOUSEMOVE = &H200
Public Const NIF_MESSAGE = &H1
Public Const NIF_ICON = &H2
Public Const NIF_TIP = &H4

Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_RBUTTONDBLCLK = &H206
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205
Public Const WM_NCLBUTTONDOWN = &HA1

Private Const SND_ALIAS = &H10000
Private Const SND_ASYNC = &H1
Private Const SND_NODEFAULT = &H2

Public Const GWL_EXSTYLE = (-20)
Public Const GWL_STYLE = -16
Public Const GWL_WNDPROC = (-4&)

Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_HIDEREADONLY = &H4
Private Const OFN_PATHMUSTEXIST = &H800

Public Const FO_MOVE = &H1
Public Const FO_COPY = &H2
Public Const FO_DELETE = &H3
Public Const FO_RENAME = &H4

Private Const HTCAPTION = 2

Private Const CC_SOLIDCOLOR = &H80
Private Const CC_FULLOPEN = &H2

Public Const FOF_ALLOWUNDO = &H40
Public Const FOF_MULTIDESTFILES = &H1
Public Const FOF_CONFIRMMOUSE = &H2
Public Const FOF_SILENT = &H4
Public Const FOF_RENAMEONCOLLISION = &H8
Public Const FOF_NOCONFIRMATION = &H10
Public Const FOF_WANTMAPPINGHANDLE = &H20
Public Const FOF_FILESONLY = &H80
Public Const FOF_SIMPLEPROGRESS = &H100
Public Const FOF_NOCONFIRMMKDIR = &H200
Public Const FOF_NOERRORUI As Long = &H400

Private Const LB_ITEMFROMPOINT = &H1A9

Private Const VER_PLATFORM_WIN32s = 0
Private Const VER_PLATFORM_WIN32_WINDOWS = 1
Private Const VER_PLATFORM_WIN32_NT = 2

Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2
Public Const SWP_FRAMECHANGED = &H20

Private Const HWND_NOTOPMOST = -2
Public Const HWND_TOPMOST = -1

Private Const PROCESS_QUERY_INFORMATION = 1024
Private Const PROCESS_VM_READ = 16

Public Enum SystemButtons
    sbCLOSEBOX = 0
    sbMINIMIZEBOX = 1
    sbMAXIMIZEBOX = 2
    sbRESIZEABLE = 3
    sbBORDER = 4
    sbCONTROLBOX = 5
    sbSHOWINTASKBAR = 7
    sbMOVEABLE = 8
End Enum

Private Const TH32CS_SNAPPROCESS As Long = 2&

Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion      As Long
    dwMinorVersion      As Long
    dwBuildNumber       As Long
    dwPlatformId        As Long
    szCSDVersion        As String * 128
End Type

Private Type PROCESSENTRY32
    dwSize              As Long
    cntUsage            As Long
    th32ProcessID       As Long
    th32DefaultHeapID   As Long
    th32ModuleID        As Long
    cntThreads          As Long
    th32ParentProcessID As Long
    pcPriClassBase      As Long
    dwFlags             As Long
    szexeFile           As String * MAX_PATH
End Type

Public Type BROWSEINFO
    hWndOwner      As Long
    pidlRoot       As Long
    pszDisplayName As String
    lpszTitle      As String
    ulFlags        As Long
    lpfn           As Long
    lParam         As Long
    iImage         As Long
End Type

Public Enum SYSTEMSOUNDNFO
    ssQUESTION = 0
    ssEXCLAIMATION = 1
    ssHAND = 2
    ssMAXIMIZE = 3
    ssMENUCOMMAND = 4
    ssMENUPOPUP = 5
    ssMIMIMIZE = 6
    ssMAIL = 7
    ssOPEN = 8
    ssCLOSE = 9
    ssAPPGPFAULT = 10
    ssDEFAULT = 11
    ssASTERISK = 12
    ssRESTOREUP = 13
    ssRESTOREDOWN = 14
    ssSYSTEMEXIT = 15
    ssSYSTEMSTART = 16
End Enum

Public Enum AddTextNFO
    Add_to_Begin = 1
    Add_to_End = 2
End Enum

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Enum pNFO
    mmPLAY = 1
    mmSTOP = 0
    mmPAUSE = 2
    mmRESUME = 3
End Enum

Public Const lABC As String = "abcdefghijklmnopqrstuvwxyz"
Public Const uABC As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

Public Const Bitte As String = "Bitte Verzeichnis angeben !"

Public Type ClNFO
    hWnd  As Long
    Class As String
    Name  As String
End Type

Public Enum TimeInfoNFO
    tiCREATED = 1
    tiLASTACCESS = 2
    tiLASTCHANGED = 3
End Enum

Public Enum tbEVENTnfo
    tbKEYDOWN = 0
    tbCHANGE = 1
End Enum

Public My As MyNFO

Public Pre() As String
Public Ta()  As String
Public Co()  As String
Public uTl() As String

Public Cl()  As ClNFO

Private strSelectCustomFolderPath As String
Private strInvalidSelectionMsg As String, strInvalidSelectionTitle As String
Private tTask() As Long
Private ttCount As Long
Public Function GetDir(ByVal Directory As String) As String
    
    GetDir = Directory
    If Right$(GetDir, 1) <> "\" Then GetDir = GetDir & "\"
    
End Function
Public Function CheckDir() As Boolean
    Dim S As Boolean
    
    If Len(My.Source) Then
        Call DirExist(My.Source, True)
        
        If Not DirExist(My.Source) Then
            DG "Error creating Directory My.Source '" & My.Source & "'"
            
            Call MsgBox(frmMain.hWnd, "Fehler", _
                        "Das zu berwachende Verzeichnis '" & My.Source & "' ist nicht vorhanden und kann nicht angelegt werden !" & _
                        vbCrLf & vbCrLf & _
                        "Bitte geben Sie ein neues Verzeichnis an, welches berwacht werden soll." & vbCrLf, _
                        vbCritical + vbOKOnly)
                            
            My.Source = ""
            S = True
        End If
    End If
    
    If Len(My.Destination) Then
        If Not DirExist(My.Destination) Then Call CreatePath(My.Destination)
    
        If Not DirExist(My.Destination) Then
            DG "Error creating Directory My.Destination '" & My.Destination & "'"

            Call MsgBox(frmMain.hWnd, "Fehler", _
                        "Das Zielverzeichnis '" & My.Destination & "' kann nicht angelegt werden." & _
                        vbCrLf & vbCrLf & _
                        "Bitte geben Sie ein neues Zielverzeichnis an." & vbCrLf, _
                        vbCritical + vbOKOnly)
        
            My.Destination = ""
            S = True
        End If
    End If
    
    If S Then Call frmMain.SetText
    
    If Len(My.Destination) > 0 And Len(My.Source) > 0 Then CheckDir = True
    
End Function
Public Sub DG(ByVal dText As String)
    Dim R$
        
    On Local Error Resume Next
    
    R$ = IIf(Len(dText) > 0, _
             Date & " / " & Time & " ~~> " & dText, "")
        
    With frmMain
        .LBdebug.AddItem R$

        Do While Err.Number <> 0
            Err.Clear
            
            .LBdebug.RemoveItem 0
            .LBdebug.AddItem R$
        Loop
    
        .LBdebug.ListIndex = .LBdebug.ListCount - 1
    End With
    
    Call LogFile(My.Log, dText, 50000)
    
End Sub
Public Sub TaskList()
    Dim P As Long
    Dim S$
      
    DG "Writing User Tasklist..."
        
    If isArray(uTl) Then
        For P = 0 To UBound(uTl)
            S$ = S$ & uTl(P) & vbCrLf
        Next P
                
        If Len(S$) Then S$ = Mid$(S$, 1, Len(S$) - 2)
    End If
    
    Call TextFile_WriteText(My.TaskList, S$, True)

End Sub
Sub Main()
    
    If App.PrevInstance Then
        Call PlaySystemSound(ssASTERISK)
        Call Sleep(1000)
        
        End
    End If
    
    frmMain.Show

End Sub
Public Sub SetColor(frm As Form)
    Dim R$, Color As String
    Dim C As Control
    
    Color = CStr(Convert_ColorToHTML(My.Color))
    DG "Set ControlColor to " & Color
    
    frm.BackColor = My.Color
    
    For Each C In frm
        R$ = LCase$(C.Name)
        
        If InStr(R$, "frame") > 0 Or _
            InStr(R$, "text") > 0 Or _
            R$ = "lbfiles" Or R$ = "lbdebug" Or R$ = "lb" Then _
                C.BackColor = My.Color: _
                C.Refresh
    Next C
    
    frm.Refresh
    
End Sub
Public Function AddFilesFromPath(LBCB As Object, ByVal Path As String, _
                                 Optional ClearBeforAdding As Boolean = True) As Boolean
    Dim Fl() As String, Dl() As String
        
    If Read(Path, Dl, Fl, True, True, True) Then _
        If lbAddArray(LBCB, Fl, ClearBeforAdding) Then AddFilesFromPath = True
    
End Function
Public Function Get_PrefixFromPath(ByVal Path As String) As String
    Dim X As Long
        
    If Right$(Path, 1) = "." Then Exit Function
    
    X = inBStr(Path, ".")
    
    If X > 0 Then Get_PrefixFromPath = Mid$(Path, X + 1)
    
End Function
Public Function ArrFind(ByVal sArray As Variant, _
                        ByVal ToFind As Variant, _
                        Optional StartIndex = -1, _
                        Optional EndIndex As Long = -1, _
                        Optional FindExact As Boolean = False) As Long
    Dim P As Long, sI As Long, eI As Long
    
    On Local Error GoTo Quit
    
    If Not FindExact Then ToFind = LCase$(ToFind)
        
    If StartIndex > -1 Then
        sI = StartIndex
    Else
        sI = LBound(sArray)
    End If
    
    If EndIndex > -1 Then
        eI = EndIndex
    Else
        eI = UBound(sArray)
    End If
        
    For P = sI To eI
        If IIf(FindExact, CStr(sArray(P)), CStr(LCase$(sArray(P)))) = ToFind Then ArrFind = P: _
                                                                                  Exit Function
    Next P
    
    ArrFind = -1
    
Quit:
    If Err.Number <> 0 Then ArrFind = -2
    
End Function
Public Function Get_FileLen(ByVal File As String) As Long
    
    On Local Error Resume Next
    
    Get_FileLen = -1
    Get_FileLen = FileLen(File)

End Function
Public Function Get_FileTime(ByVal File As String, _
                             ByVal FileInfo As TimeInfoNFO, _
                             Optional TimeOnly As Boolean = False, _
                             Optional DateOnly As Boolean = False) _
                                    As Date
    Dim DTformat As String, A() As String
    Dim hFile As Long
    Dim OFS As OFSTRUCT
    Dim cTime As FILETIME, lTime As FILETIME, lwTime As FILETIME
    Dim sTime As SYSTEMTIME
     
    On Local Error Resume Next
    
    OFS.cBytes = Len(OFS)
    hFile = OpenFile(File, OFS, OF_READ)
    
    If hFile > 0 Then
        DTformat = "dd.mm.yyyy hh:mm:ss"
        Call GetFileTime(hFile, cTime, lTime, lwTime)
        
        Select Case FileInfo
            Case tiCREATED
                Call FileTimeToSystemTime(cTime, sTime)
                Get_FileTime = Format$(CalcFTime(sTime), DTformat)
            Case tiLASTACCESS
                Call FileTimeToSystemTime(lTime, sTime)
                Get_FileTime = Format$(CalcFTime(sTime), DTformat)
            Case tiLASTCHANGED
                Call FileTimeToSystemTime(lwTime, sTime)
                Get_FileTime = Format$(CalcFTime(sTime), DTformat)
            Case Else: Exit Function
        End Select
    
        Call CloseHandle(hFile)
                
        If TimeOnly Or DateOnly Then _
            A = VBA.Split(Get_FileTime, Chr$(32)): _
            Get_FileTime = A(0): _
            If TimeOnly Then Get_FileTime = A(1)
    Else
        Get_FileTime = CDate(0)
    End If
    
Quit:
End Function
Public Function isArray(Var As Variant) As Boolean
    Dim X As Long
    
    On Local Error Resume Next
    X = LBound(Var)
    
    isArray = (Err.Number = 0 Or Err.Number = 9)
    
End Function
Public Function lbFindItem(LBCB As Object, _
                           ByVal Find As String, _
                           Optional FindExact As Boolean = False) _
                                As Long
    Dim P As Long, cmd As Long
    
    On Local Error GoTo Quit
    
    cmd = Cis(LBCB.hWnd, cisFINDSTRINGEXACT)
    If cmd = -2 Then lbFindItem = cmd: Exit Function
                     
    lbFindItem = SearchLB(LBCB.hWnd, cmd, -1, Find)
        
    If Not FindExact Then Find = LCase$(Find)
    
    For P = lbFindItem To LBCB.ListCount - 1
        If IIf(FindExact, LBCB.List(P), LCase$(LBCB.List(P))) = Find Then _
            lbFindItem = P: _
            Exit Function
    Next P
        
    lbFindItem = -1
    
Quit:
    If Err Then lbFindItem = -3
    
End Function
Public Function FileExist(ByVal File As String) As Boolean
    Dim FN As Integer

    On Local Error GoTo Quit
    
    FN = FreeFile
    
    Open File For Input As FN
    Close FN

    FileExist = True
    
Quit:
End Function
Public Function Get_DirectoryFromPath(ByVal Path As String) As String
    On Local Error Resume Next
    
    If Right$(Path, 1) = "\" Then
        Get_DirectoryFromPath = Path
    Else
        Get_DirectoryFromPath = GetDir(Mid$(Path, 1, SplitPath(Path) - 1))
    End If
    
End Function
Public Function BinCopy(ByVal SourceFile As String, _
                        ByVal TargetDirectory As String, _
                        Optional OverwriteExist As Boolean = True, _
                        Optional ShowProgress As Boolean = False, _
                        Optional MessageText As String = "") _
                                As Long
    Dim X As Long, Max As Long, L As Long, P As Long
    Dim Target As String
    Dim frm As New ProgBar
            
    On Local Error GoTo Quit
    
    If Not FileExist(SourceFile) Then BinCopy = 0: _
                                      GoTo Quit
    
    TargetDirectory = GetDir(TargetDirectory)
        
    If Not DirExist(TargetDirectory, False) Then _
        If Not CreatePath(TargetDirectory) Then _
            BinCopy = -1: _
            GoTo Quit
        
    X = SplitPath(SourceFile)
    Target = TargetDirectory & Mid$(SourceFile, X + 1)
    
    If FileExist(Target) Then
        If Not OverwriteExist Then BinCopy = -2: _
                                   GoTo Quit
        If fKill(Target) <> 0 Then BinCopy = -3: _
                                   GoTo Quit
    End If
    
    Max = 1024000
    L = FileLen(SourceFile)

    If ShowProgress Then
        Load frm
        frm.Tag = "BinCopy"
            
        Call frm.SetOption(0, L, MessageText, True)
    End If
        
    X = 0
        
    Open SourceFile For Binary As 3
    Open Target For Binary As 1

        For P = 0 To L Step Max
            If ShowProgress And P = 0 Then _
                frm.Message.Caption = SourceFile & " -> " & Target
                
            If L - P < Max Then
                X = X + (L - P)
                ByteCopy L - P, 3, 1
            Else
                X = X + Max
                ByteCopy Max, 3, 1
            End If
                
            If ShowProgress Then Call frm.SetValue(X)
          
            DoEvents
        Next P
            
    Close 3
    Close 1
    
    BinCopy = 1
    
Quit:
    If ShowProgress Then Unload frm
    Set frm = Nothing

    If Err.Number <> 0 Then BinCopy = Err.Number
    
End Function
Public Function PlayMultimediaFile(Command As pNFO, _
                                   ByVal File As String) _
                                   As Boolean
    Dim oStr As String
    
    File = Get_DOSfileName(File)
    
    Select Case Command
        Case mmSTOP
            oStr = "stop"
        Case mmPLAY, mmRESUME
            oStr = "play"
        Case mmPAUSE
            oStr = "pause"
    End Select
    
    oStr = oStr & " " & File
    
    If mciSendString(oStr, 0&, 0, 0) = 0 Then _
        PlayMultimediaFile = True
    
End Function
Public Function TextFile_AddText(ByVal TF_TextFile As String, _
                                 ByVal TF_Text As String, _
                                 Add_To As AddTextNFO) As Boolean
    Dim FN As Integer
    Dim Str As String
    
    On Local Error GoTo Quit
    
    Select Case Add_To
        Case Add_to_Begin
            Str = TF_Text & vbCrLf & TextFile_Read(TF_TextFile)
            TextFile_AddText = TextFile_WriteText(TF_TextFile, Str, True)
        Case Add_to_End
            FN = FreeFile
    
            Open TF_TextFile For Append As FN
                Print #FN, TF_Text
            Close FN
            
            TextFile_AddText = True
    End Select
    
Quit:
End Function
Public Function fKill(ByVal File As String) As Long
    
    On Local Error Resume Next
    
    If Not FileExist(File) Then fKill = -1: _
                                Exit Function
    
    Call SetAttr(File, vbNormal)
    Err.Clear
        
    Kill File
    
    fKill = Err.Number
    
End Function
Public Function Get_FileFromPath(ByVal Path As String) As String
    
    On Local Error Resume Next
    
    If Right$(Path, 1) <> "\" Then _
        Get_FileFromPath = Mid$(Path, SplitPath(Path) + 1)
        
End Function
Public Function FileOperation(Operation As FileOperationNFO, _
                              ByVal Source As String, _
                              ByVal Target As String, _
                              Optional MoveToRecycleBin As Boolean = False) _
                                    As Boolean
                                    
    FileOperation = SH_FileOperation(CLng(0), Operation, _
                                     Source, Target, _
                                     False, False, False, _
                                     False, MoveToRecycleBin)
End Function
Public Function AddProcessList(LBCB As Object, Optional ClearBeforAdding As Boolean = True) As Boolean
    Dim E() As String
    Dim I() As Long
    
    On Local Error GoTo Quit
    
    If Get_ProcessList(E, I) Then _
        AddProcessList = lbAddArray(LBCB, E, ClearBeforAdding)
    
Quit:
End Function
Public Function ArrDeleteIndex(sArray As Variant, ByVal Index As Long) As Long
    Dim P As Long
    Dim A As Variant
    
    On Local Error GoTo Quit
    
    A = sArray
    
    If UBound(sArray) = 0 And Index = 0 Then
        Erase A
    Else
        For P = Index + 1 To UBound(sArray)
            A(P - 1) = sArray(P)
        Next P
    
        ReDim Preserve A(UBound(A) - 1)
    End If
    
    sArray = A

Quit:
    ArrDeleteIndex = Err.Number
    
End Function
Public Function ArrWriteToFile(sArray As Variant, ByVal FILENAME As String) As Long
    Dim P As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    For P = LBound(sArray) To UBound(sArray)
        R$ = R$ & sArray(P) & vbCrLf
    Next P
    
    If Len(R$) Then R$ = Mid$(R$, 1, Len(R$) - 2)
    
    ArrWriteToFile = TextFile_WriteText(FILENAME, R$, True)
    
Quit:
End Function
Public Sub Execute(AppPath As String, Optional Param As String = "")
    Call ShellExecute(0, "Open", AppPath, Param, "", 1)
End Sub
Public Function Get_LBound(sArray As Variant) As Long
    Dim X As Long
    
    On Local Error Resume Next
    
    X = LBound(sArray)
    
    Select Case Err.Number
        Case 0:    Get_LBound = X
        Case 9:    Get_LBound = -1
        Case 13:   Get_LBound = -2
        
        Case Else: Get_LBound = -3
    End Select
    
    Err.Clear
    
End Function
Public Function Get_UBound(sArray As Variant) As Long
    Dim X As Long
    
    On Local Error Resume Next
    
    X = UBound(sArray)
    
    Select Case Err.Number
        Case 0:    Get_UBound = X
        Case 9:    Get_UBound = -1
        Case 13:   Get_UBound = -2
        
        Case Else: Get_UBound = -3
    End Select
    
    Err.Clear
    
End Function
Public Function PlaySystemSound(Sound As SYSTEMSOUNDNFO) As Boolean
    Dim SND As String
    Dim Result As Long
    
    On Local Error GoTo Quit
    
    Select Case Sound
        Case ssAPPGPFAULT:   SND = "AppGPFault"
        Case ssASTERISK:     SND = "SystemAsterisk"
        Case ssCLOSE:        SND = "Close"
        Case ssDEFAULT:      SND = ".Default"
        Case ssEXCLAIMATION: SND = "SystemExclaimation"
        Case ssHAND:         SND = "SystemHand"
        Case ssMAIL:         SND = "MailBeep"
        Case ssMAXIMIZE:     SND = "Maximize"
        Case ssMENUCOMMAND:  SND = "MenuCommand"
        Case ssMENUPOPUP:    SND = "MenuPopup"
        Case ssMIMIMIZE:     SND = "Minimize"
        Case ssOPEN:         SND = "Open"
        Case ssQUESTION:     SND = "SystemQuestion"
        Case ssRESTOREDOWN:  SND = "RestoreDown"
        Case ssRESTOREUP:    SND = "RestoreUp"
        Case ssSYSTEMEXIT:   SND = "SystemExit"
        Case ssSYSTEMSTART:  SND = "SystemStart"
        
        Case Else:           Exit Function
    End Select
    
    Result = PlaySound(SND, 0, SND_ALIAS Or SND_ASYNC Or SND_NODEFAULT)

    PlaySystemSound = (Result = 1)
    
Quit:
End Function
Public Sub Sleep(ByVal MilliSeconds As Long)
    Call SleepA(MilliSeconds)
End Sub
Public Function Write_INI(ByVal INIpath As String, _
                          ByVal Section As String, _
                          ByVal Abschnitt As String, _
                          ByVal Value As String, _
                          Optional ReplacevbCrlf As String = "") As Boolean
    
    If ReplacevbCrlf <> "" Then Value = Replace(Value, vbCrLf, ReplacevbCrlf)
    
    If WritePrivateProfileString(Section, Abschnitt, Value, INIpath) Then Write_INI = True

End Function
Public Function Read_INI(ByVal INIpath As String, _
                         ByVal Section As String, _
                         ByVal Abschnitt As String, _
                         Optional ReplacevbCrlf As String = "") As String
   Dim RetStr As String
   
   RetStr = String(255, Chr$(0))
   
   Read_INI = Left$(RetStr, GetPrivateProfileString(Section, Abschnitt, "", RetStr, Len(RetStr), INIpath))
                                            
    If ReplacevbCrlf <> "" Then Read_INI = Replace(Read_INI, ReplacevbCrlf, vbCrLf)

End Function
Public Function TextFile_Read(ByVal TF_TextFile As String) As String
    Dim FN As Integer
    
    On Local Error GoTo Quit
    
    FN = FreeFile()
    
    Open TF_TextFile For Binary Access Read As #FN
        TextFile_Read = Space(LOF(FN))
        Get #FN, , TextFile_Read
    Close #FN
    
    If Right$(TextFile_Read, 2) = vbCrLf Then TextFile_Read = Left$(TextFile_Read, Len(TextFile_Read) - 2)
          
Quit:
    If Err.Number <> 0 Then TextFile_Read = ""
    
End Function
Public Function Hyperlink_Create(Label As Object, _
                                 ByVal LabelColor As Long, _
                                 ByVal LabelColorMouseOver As Long) _
                                    As Boolean
    
    Call frmMain.Create_Hyperlink(Label.Parent, Label, LabelColor, LabelColorMouseOver)

End Function
Public Function Form(ByVal sForm As Object, _
                     But As SystemButtons, _
                     Optional Enable As Boolean = True) _
                            As Boolean
    Dim M As String
    Dim Style As Long, lngStyle As Long, xStyle As Long
    Dim nVisible As Boolean
        
    xStyle = GWL_STYLE
    M = ""

    Select Case But
        Case sbMAXIMIZEBOX
            Style = WS_MAXIMIZEBOX
            M = "Ma&ximieren"
        Case sbMINIMIZEBOX
            Style = WS_MINIMIZEBOX
            M = "Mi&nimieren"
        Case sbRESIZEABLE
            Style = WS_SIZEBOX
        Case sbBORDER
            Style = WS_CAPTION
        Case sbCONTROLBOX
            Style = WS_SYSMENU
        Case sbSHOWINTASKBAR
            Style = WS_EX_APPWINDOW
            xStyle = GWL_EXSTYLE
        Case Else
            Exit Function
    End Select

    lngStyle = GetWindowLongA(sForm.hWnd, xStyle)
    Call SetLastError(0)

    Select Case xStyle
        Case GWL_STYLE
            lngStyle = IIf(Enable, lngStyle Or Style, _
                                   lngStyle - Style)
                         
            Call SetWindowLong(sForm.hWnd, GWL_STYLE, lngStyle)
            
            If GetLastError = 0 Then
                Form = True
            End If
            
            Call Update(sForm)
        Case GWL_EXSTYLE
            nVisible = sForm.Visible
            sForm.Visible = False
                              
            lngStyle = IIf(Enable, lngStyle Or Style, _
                                   lngStyle And Not Style)
        
            Call SetWindowLong(sForm.hWnd, GWL_EXSTYLE, lngStyle)
            If GetLastError = 0 Then Form = True

            sForm.Refresh
            sForm.Visible = nVisible
    End Select

End Function
Public Function SysTray_Refresh() As Boolean
    Dim X As Long, Z As Long, hWnd As Long
    Dim rRect As RECT
    
    On Local Error GoTo Quit

    hWnd = FindSysTray
    
    If hWnd = 0 Then Exit Function
    
    X = GetClientRect(hWnd, rRect)

    For Z = 0 To (rRect.Bottom / 20) - 1
        For X = 0 To rRect.Right
            Call SendMessage(hWnd, WM_MOUSEMOVE, 0, _
                             ByVal ((((Z * 20) + 10) * &H10000) Or X))
        Next X
    Next Z
    
    SysTray_Refresh = True

Quit:
End Function
Public Function Center(Form As Object, _
                       CenterWhere As cCenterNFO, _
                       Optional hWnd As Long) As Boolean
    Dim L As Long, T As Long
    Dim rl As Long, rt As Long, rr As Long, rb As Long
            
    On Local Error GoTo Quit

    Select Case CenterWhere
        Case ccMIDDLE
            T = (Screen.Height / 2) - (Form.Height / 2)
        Case Else: Exit Function
    End Select

    L = (Screen.Width / 2) - (Form.Width / 2)

    Form.Left = L
    Form.Top = T
    
    Form.Refresh
    
    Center = True
    
Quit:
End Function
Public Function LogFile(ByVal File As String, _
                        ByVal LogText As String, _
                        Optional FileSizeLimitBytes As Long = -1) _
                            As String
    Dim sText As String, R$
        
    sText = TextFile_Read(File)
    
    If Len(LogText) > 0 Then
        R$ = Date & "/" & Time & " -> " & LogText
        sText = sText & R$ & vbCrLf
    Else
        sText = sText & vbCrLf
        R$ = ""
    End If
    
    If FileSizeLimitBytes > 0 Then _
        sText = Right$(sText, FileSizeLimitBytes - 2)
    
    If TextFile_WriteText(File, sText, True) Then _
        LogFile = R$
        
End Function
Public Function TextFile_WriteText(ByVal TF_TextFile As String, _
                                   ByVal TF_Text As String, _
                                   Optional OverwriteExist As Boolean = False) As Long
    Dim FN As Integer
        
    On Local Error GoTo Quit
    
    If FileExist(TF_TextFile) Then
        If Not OverwriteExist Then Exit Function
        
        Call fKill(TF_TextFile)
    End If
    
    FN = FreeFile
    
    Open TF_TextFile For Output As FN
        Print #FN, TF_Text
    Close FN

Quit:
    TextFile_WriteText = Err.Number

End Function
Public Function DirExist(ByVal Path As String, _
                         Optional sCreatePath As Boolean = False) _
                            As Boolean
    Dim Fs As Object
   
    Set Fs = CreateObject("Scripting.FileSystemObject")
    
    If Fs.FolderExists(Path) Then
        DirExist = True
    Else
        If sCreatePath Then DirExist = CreatePath(Path)
    End If
        
End Function
Public Function MsgBox(ByVal hWnd As Long, _
                       ByVal Title As String, _
                       ByVal Prompt As String, _
                       ByVal Button As VbMsgBoxStyle) _
                            As VbMsgBoxResult
        
    MsgBox = MessageBox(hWnd, Prompt, Title, CLng(Button))
    
Quit:
End Function
Public Function CreatePath(ByVal Path As String) As Boolean
    Call MakePath(GetDir(Path))
    If DirExist(Path, False) Then CreatePath = True
End Function
Public Function Find_Form(pForms As Object, _
                          Optional FormName As String, _
                          Optional FormCaption As String, _
                          Optional FormTag As String, _
                          Optional FindExact As Boolean = True) _
                                As Long
    Dim P As Integer
    Dim MustBe As Integer, Ok As Integer
    Dim Fc As String, ft As String
    
    MustBe = 0
    
    If FormName <> "" Then MustBe = 1
    If FormCaption <> "" Then MustBe = MustBe + 1
    If FormTag <> "" Then MustBe = MustBe + 1
    
    If Not FindExact Then _
        FormTag = LCase(FormTag): _
        FormCaption = LCase(FormCaption)
        
    FormName = LCase(FormName)

    For P = 0 To pForms.Count - 1
        Ok = 0
        
        If FormName <> "" Then
            If LCase(pForms(P).Name) = FormName Then
                Ok = 1
            Else
                GoTo GetNextForm
            End If
        End If
        
        If FormCaption <> "" Then
            Fc = pForms(P).Caption
            If Not FindExact Then Fc = LCase(Fc)
            
            If Fc = FormCaption Then
                Ok = Ok + 1
            Else
                GoTo GetNextForm
            End If
        End If
                    
        If FormTag <> "" Then
            ft = pForms(P).Tag
            If Not FindExact Then ft = LCase(ft)
            If ft = FormTag Then Ok = Ok + 1
        End If
        
GetNextForm:
        If Ok = MustBe Then _
            Find_Form = P: _
            Exit Function

    Next P
    
    Find_Form = -1
    
End Function
Public Function BrowseForDirectory(ByVal hWnd As Long, _
                                   ByVal Title As String, _
                                   Optional SysRoot As enum_ShellSpecialFolder, _
                                   Optional SelectedSysFolder As enum_ShellSpecialFolder, _
                                   Optional RootPath As String, _
                                   Optional SelectedFolderPath As String, _
                                   Optional uFlags As ShellBrowseFlags, _
                                   Optional returnedFolderName As String, _
                                   Optional InvalidSelectionMSG As String, _
                                   Optional InvalidSelectionTitle As String) As String

    BrowseForDirectory = ShellBrowseForFolder(hWnd, Title, , SysRoot, RootPath, _
                                              SelectedFolderPath, SelectedSysFolder, uFlags, _
                                              InvalidSelectionMSG, InvalidSelectionTitle)

End Function
Public Function Show_FileDialogOpen(ByVal hWnd As Long, _
                                    Optional FILTER As String = "*.*", _
                                    Optional XPOS As Long = -1, _
                                    Optional YPOS As Long = -1) _
                                            As String
    Dim Buffer As String
    Dim FLAGS As Long
    Dim ComDlgOpenFileName As OPENFILENAME
      
    FLAGS = OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
        
    Buffer = String$(128, 0)
   
    With ComDlgOpenFileName
        .lStructSize = Len(ComDlgOpenFileName)
        .hWndOwner = hWnd
        .FLAGS = FLAGS
        .nFilterIndex = 1
        .nMaxFile = Len(Buffer)
        .lpstrFile = Buffer
        .lpstrFilter = FILTER
    End With
    
    If GetOpenFileName(ComDlgOpenFileName) Then _
        Show_FileDialogOpen = Left$(ComDlgOpenFileName.lpstrFile, InStr(ComDlgOpenFileName.lpstrFile, Chr$(0)) - 1)
    
End Function
Public Function isFilePlayable(ByVal File As String) As Boolean
    Dim mssg As String * 255
        
    File = Get_DOSfileName(File)

    If mciSendString("capability " & File & " can play", mssg, 255, 0) = 0 Then
        If InStr(LCase$(mssg), "true") Then isFilePlayable = True
    End If
    
End Function
Public Function ColorDlg(ByVal hWnd As Long, _
                         Optional ByVal ExtColors As Boolean = False) _
                                As Long
    Dim nCustColor(16) As Long
    Dim pColor As LPCHOOSECOLOR
        
    ColorDlg = -1
    
    With pColor
        .lStructSize = Len(pColor)
        .hWnd = hWnd
        .hInstance = CLng(0)
        
        .FLAGS = IIf(ExtColors, _
                     CC_SOLIDCOLOR Or CC_FULLOPEN, _
                     CC_SOLIDCOLOR)
        
        .lpCustColors = String$(16 * 4, 0)

        If ChooseColor(pColor) Then ColorDlg = .rgbResult
    End With

End Function
Public Sub Explorer_OpenPath(Path As String)
    Call Execute(Path)
End Sub
Public Sub FormMove(Form As Object)
    Call ReleaseCapture
    Call SendMessage(Form.hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0&)
End Sub
Public Function Animate(Form As Object, _
                        AniTyp As ANIMETNFO, _
                        Optional Speed As Long = 5) As Boolean
    Dim Ani As Long
    
    On Local Error GoTo Quit
    
    Select Case AniTyp
        Case anFADEIN: Ani = 524288
        Case anDOWN_TO_UP: Ani = 262152
        Case anLEFT_TO_RIGHT: Ani = 262145
        Case anUPPERLEFT_TO_LOWERRIGHT: Ani = 5
        Case anMIDDLE: Ani = 16
        Case anRIGHT_TO_LEFT: Ani = 262146
        Case anUPERRIGHT_TO_LOWERLEFT: Ani = 6
        Case anUP_TO_DOWN: Ani = 262148
        Case anFADEOUT: Ani = 589824
    End Select
    
    Call AnimateWindow(Form.hWnd, (Speed * 100), Ani)
    
    Form.Refresh
    
    Animate = True
    
Quit:
End Function
Public Sub SendNewMail(ByVal MailTo As String, _
                       ByVal Subject As String, _
                       ByVal Body As String)
    Dim Buff As String
    
    Buff = "mailto:" & MailTo & "?Subject=" & _
           Subject & "&Body=" & Body
    
    Call ShellExecute(0&, "Open", Buff, "", "", 1)

End Sub
Public Sub OpenURL(ByVal URL As String)
    Call IE_Open(URL)
End Sub
Public Sub IE_Open(Optional URL As String = "")
    Call Execute("Iexplore.exe", URL)
End Sub
Public Function LB_MouseMove(LB As Object, _
                             ByVal Button As Integer, _
                             ByVal Shift As Integer, _
                             ByVal X As Single, _
                             ByVal Y As Single, _
                             Optional SetMousePointer As Boolean = True, _
                             Optional SetToolTip As Boolean = True) _
                                    As Long
    Dim Index As Long, MP As Long
    Dim TT$
    
    On Local Error GoTo Quit
    
    Index = LB_GetIndexUnderMouse(LB, Button, Shift, X, Y)
    
    If Index >= LB.ListCount Then
        Index = -1
        MP = 12
        TT$ = ""
    Else
        MP = 0
        TT$ = LB.List(Index)
    End If
    
    LB_MouseMove = Index
    LB.ListIndex = Index
    
    If SetMousePointer Then LB.MousePointer = MP
    If SetToolTip Then LB.ToolTipText = TT$
    
    Exit Function
    
Quit:
    LB_MouseMove = -2

End Function
Public Function FindWindow(ByVal ClassName As String, _
                           ByVal Caption As String) As Long
    
    If ClassName = "" Then ClassName = vbNullString
    If Caption = "" Then Caption = vbNullString
    
    FindWindow = FindWindowA(ClassName, Caption)
    
End Function
Public Function Read(ByVal Directory As String, _
                     DirList As Variant, _
                     FileList As Variant, _
                     Optional SystemFiles As Boolean = True, _
                     Optional ReadOnlyFiles As Boolean = True, _
                     Optional HiddenFiles As Boolean = True) _
                        As Boolean
    Dim File As String
    Dim X As Long, Y As Long
    Dim At As VbFileAttribute
    
    Erase DirList: Erase FileList
    
    If Not DirExist(Directory) Then Exit Function
    
    At = vbDirectory
    
    If SystemFiles Then At = At + vbSystem
    If ReadOnlyFiles Then At = At + vbReadOnly
    If HiddenFiles Then At = At + vbHidden

    Directory = GetDir(Directory)
    
    File = Directory
    File = Dir(File & "*.*", At)
    
    On Local Error Resume Next
    
    Do While Len(File)
        If File <> "." And File <> ".." Then
            If (GetAttr(Directory & File) And vbDirectory) = vbDirectory Then
                If Err = 0 Then _
                    ReDim Preserve DirList(X): _
                    DirList(X) = File: _
                    X = X + 1
            Else
                ReDim Preserve FileList(Y)
                FileList(Y) = File
                Y = Y + 1
            End If
            Err.Clear
        End If
        File = Dir
    Loop
    
    Read = True
    
Quit:
End Function
Public Function lbAddArray(LBCB As Object, _
                         sArray As Variant, _
                         Optional ClearBeforeAdding As Boolean = True) As Long
    Dim P As Long
    
    On Local Error GoTo Quit
    
    If ClearBeforeAdding Then LBCB.Clear
    
    For P = LBound(sArray) To UBound(sArray)
        LBCB.AddItem sArray(P)
    Next P

Quit:
    If Err.Number <> 0 Or Err.Number <> 9 Then lbAddArray = Err.Number

End Function
Public Function inBStr(ByVal Str As String, _
                       ByVal Find As String) As Long
    inBStr = InStrRev(Str, Find)
End Function
Private Function CalcFTime(FTime As SYSTEMTIME) As Date
    Dim Datum As String, Zeit As String, aa As String
    Dim mm As String, SS As String, DT As Date
    Dim Da As String, Mo As String, Ye As String

    With FTime
        Da = .wDay
        If Len(Da) < 2 Then Da = "0" & Da
    
        Mo = .wMonth
        If Len(Mo) < 2 Then Mo = "0" & Mo
    
        Ye = CStr(.wYear)
        Datum = Da & "." & Mo & "." & Ye
    
        mm = Trim$(CStr(.wMinute))
        If Len(mm) < 2 Then mm = "0" & mm
    
        SS = Trim$(CStr(.wSecond))
        If Len(SS) < 2 Then SS = "0" & SS
    
        Zeit = .wHour & ":" & mm & ":" & SS
        DT = CDate(Datum & " " & Zeit)
        CalcFTime = DT
    End With

End Function
Public Function Cis(hWnd As Long, APIcmd As CISNFO) As Long
    Dim Class As String
        
    Class = LCase(Get_Class(hWnd))
    
    If InStr(Class, "listbox") And InStr(Class, "drivelist") = 0 Then
        Select Case APIcmd
            Case cisDELETESTRING: Cis = LB_DELETESTRING
            Case cisFINDSTRING: Cis = LB_FINDSTRING
            Case cisFINDSTRINGEXACT: Cis = LB_FINDSTRINGEXACT
            Case cisGETCURSEL: Cis = LB_GETCURSEL
            Case cisINSERTSTRING: Cis = LB_INSERTSTRING
            Case cisLB_SETSEL: Cis = LB_SETSEL
            Case cisRESETCONTENT: Cis = LB_RESETCONTENT
            Case cisSETCURSEL: Cis = LB_SETCURSEL
        End Select
        
        Exit Function
    End If
    
    If InStr(Class, "combobox") Or InStr(Class, "drivelist") Then
        Select Case APIcmd
            Case cisDELETESTRING: Cis = CB_DELETESTRING
            Case cisFINDSTRING: Cis = CB_FINDSTRING
            Case cisFINDSTRINGEXACT: Cis = CB_FINDSTRINGEXACT
            Case cisGETCURSEL: Cis = CB_GETCURSEL
            Case cisINSERTSTRING: Cis = CB_INSERTSTRING
            Case cisRESETCONTENT: Cis = CB_RESETCONTENT
            Case cisSETCURSEL: Cis = CB_SETCURSEL
        End Select
        
        Exit Function
    End If
    
    Cis = -2
    
End Function
Public Function SplitPath(ByVal Path As String) As Long
    SplitPath = inBStr(Path, "\")
End Function
Private Sub ByteCopy(Bytes, Quelle, Ziel)
    Dim I As Long
    Dim Puffer() As Byte
  
    ReDim Puffer(1 To 32768)
  
    For I = 0 To Bytes - 1 Step 32768
        If Bytes - I < 32768 Then ReDim Puffer(1 To Bytes - I)
        Get Quelle, , Puffer
        Put Ziel, , Puffer
    Next I

End Sub
Public Function Get_DOSfileName(ByVal Path As String) As String
    Dim Result As Long
    Dim aa As String
    
    aa = Space$(255)
    Result = GetShortPathName(Path, aa, Len(aa))
    Get_DOSfileName = Mid$(aa, 1, Result)

End Function
Public Function SH_FileOperation(ByVal hWnd As Long, _
                              ByVal Operation As FileOperationNFO, _
                              ByVal pFrom As String, _
                              ByVal pTo As String, _
                              ByVal IncludingSubDirectorys As Boolean, _
                              ByVal Confirm As Boolean, _
                              ByVal ShowDialogs As Boolean, _
                              ByVal ShowProgress As Boolean, _
                              Optional MoveToRecycleBin As Boolean = False) _
                                    As Boolean
    Dim SFO As SHFILEOPSTRUCT
    Dim nPath As String, Path As String
    Dim wFunc As Long, FLAGS As Long, X As Long
    
    On Local Error GoTo Quit
    
    Select Case Operation
        Case foCOPY
            wFunc = FO_COPY
        Case foMOVE
            wFunc = FO_MOVE
        Case foRENAME
            wFunc = FO_RENAME
            
            If InStr(pTo, "\") = 0 Then _
                X = SplitPath(pFrom): _
                pTo = GetDir(Mid$(pFrom, 1, X - 1)) & pTo
        Case foDELETE
            wFunc = FO_DELETE
            pTo = ""
    End Select

    With SFO
        .hWnd = hWnd
        .wFunc = wFunc
        .pFrom = pFrom & Chr$(0)
        .pTo = pTo & Chr$(0)
        .fFlags = 0
        
        If Not IncludingSubDirectorys Then
            .fFlags = .fFlags Or FOF_FILESONLY
        Else
            If .wFunc = FO_COPY Then _
                Call CreatePath(GetDir(pTo))
        End If
        
        If ShowProgress Then _
            .fFlags = .fFlags Or FOF_SIMPLEPROGRESS
        If Not Confirm Then _
            .fFlags = .fFlags Or FOF_NOCONFIRMATION
        
        If Not ShowDialogs Then _
            .fFlags = .fFlags Or FOF_SILENT: _
            .fFlags = .fFlags Or FOF_NOERRORUI
    
        If Operation = foDELETE And MoveToRecycleBin Then _
            .fFlags = .fFlags Or FOF_ALLOWUNDO
    End With

    If SHFileOperation(SFO) = 0 Then _
        SH_FileOperation = True
        
Quit:
End Function
Public Function Get_ProcessList(aEXE As Variant, _
                                aID As Variant, _
                                Optional GetFullPath As Boolean = False) _
                                    As Boolean
    Dim lSnapshot As Long, nResult As Long, X As Long
    Dim hProcess As Long, nSize As Long, lRet As Long
    Dim uProcess As PROCESSENTRY32
    Dim Str As String, ModuleName As String, GetProcessName As String
    
    On Local Error GoTo Quit
    
    X = -1
    
    lSnapshot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)

    If isWindowsNT Then
        If lSnapshot Then
            uProcess.dwSize = Len(uProcess)
            nResult = ProcessFirst(lSnapshot, uProcess)
    
            Do Until nResult = 0
                Str = Mid$(uProcess.szexeFile, 1, _
                          InStr(uProcess.szexeFile, Chr$(0)) - 1)
            
                If GetFullPath Then
                    hProcess = OpenProcess(PROCESS_QUERY_INFORMATION _
                                           Or PROCESS_VM_READ, 0, uProcess.th32ProcessID)
                    ModuleName = Space(MAX_PATH)
                    nSize = 500
                
                    lRet = GetModuleFileNameExA(hProcess, 0, _
                                                ModuleName, nSize)
                
                    GetProcessName = Left(ModuleName, lRet)
                    lRet = CloseHandle(hProcess)
                    
                    If Len(GetProcessName) Then Str = GetProcessName
                End If
            
                Call AddArray(aEXE, Str, arTOEND)
                Call AddArray(aID, uProcess.th32ProcessID, arTOEND)
            
                nResult = ProcessNext(lSnapshot, uProcess)
            Loop
        End If
    Else
        If lSnapshot Then
            uProcess.dwSize = Len(uProcess)
            
            nResult = Process32First(lSnapshot, uProcess)
            
            Do While nResult
                Str = StrZToStr(uProcess.szexeFile)
            
                Call ArrAdd(aEXE, Str, arTOEND)
                Call ArrAdd(aID, uProcess.th32ProcessID, arTOEND)
            
                nResult = Process32Next(lSnapshot, uProcess)
            Loop
        End If
    End If
    
    Call CloseHandle(lSnapshot)

    Get_ProcessList = True
    
Quit:
    If Err Then Erase aEXE: _
                Erase aID
    
End Function
Public Function AddArray(sArray1 As Variant, ByVal sArray2 As Variant, _
                         AddTo As arADDTO, Optional ByVal Index As Long = -1) As Long
    Dim P As Long, L2 As Long, X As Long, U As Long
    Dim A As Variant, B As Variant
    
    Static C As Variant, D As Variant
    
    On Local Error GoTo Quit
    
    A = sArray1
    B = sArray2
    
    L2 = Get_LBound(B)
    
    If L2 = -1 Then Exit Function
    
    If L2 < -1 Then ReDim B(0): _
                    B(0) = sArray2: _
                    L2 = 0
                    
    Select Case AddTo
        Case arTOEND
            U = Get_UBound(A)
            
            If U = -1 Then
                ReDim sArray1(L2)
                
                For P = 0 To L2
                    sArray1(P) = B(P)
                Next P
                
                Exit Function
            End If
                
            X = UBound(B) - L2 + 1
            
            ReDim Preserve A(LBound(A) To UBound(A) + X)
            
            X = 1
            
            For P = L2 To UBound(B)
                A(U + X) = B(P)
                X = X + 1
            Next P
    
            sArray1 = A
        Case arTOBEGIN
            U = Get_UBound(A)
            
            If U = -1 Then
                ReDim sArray1(L2)
                
                For P = 0 To L2
                    sArray1(P) = B(P)
                Next P
                
                Exit Function
            End If
        
            Call AddArray(B, A, arTOEND)
            
            sArray1 = B
        Case arADDTOINDEX
            C = A
            
            ReDim D(UBound(A) - Index)
            ReDim Preserve A(LBound(A) To Index - 1)
            
            Call AddArray(A, B, arTOEND, Index)
            
            X = 0
            
            For P = Index To UBound(C)
                D(X) = C(P)
                X = X + 1
            Next P
            
            Call AddArray(A, D, arTOEND)
            
            sArray1 = A
            
            Erase C: Erase D
    End Select
    
Quit:
    AddArray = Err.Number
    Err.Clear
    
End Function
Private Sub Update(Form As Object)
    Dim R As RECT
    
    Call GetWindowRect(Form.hWnd, R)
    Call SetWindowPos(Form.hWnd, 0, R.Left, R.Top, _
                      R.Right - R.Left, R.Bottom - R.Top, _
                      SWP_FRAMECHANGED)
                      
End Sub
Public Function FindSysTray() As Long
    Dim h1 As Long, h2 As Long, h3 As Long
    Dim Wv As oS
        
    h1 = FindWindowA("Shell_TrayWnd", vbNullString)

    If h1 Then
        h2 = FindWindowEx(h1, 0, "TrayNotifyWnd", vbNullString)
    
        Wv = Get_WinVer
    
        If isWindowsNT Or Wv = osWindowsMillenium Then
            If Wv = osWindows2003 Or Wv = osWindows2000 Or Wv = osWindowsXP Then
                h2 = FindWindowEx(h2, 0, "SysPager", vbNullString)
        
                If h2 Then _
                    h3 = FindWindowEx(h2, 0, "ToolbarWindow32", vbNullString): _
                    FindSysTray = h3
            End If
        Else
            FindSysTray = h2
        End If
    End If

End Function
Public Function ShellBrowseForFolder(ByVal hWnd As Long, _
                                     ByVal Title As String, _
                                     Optional returnedFolderName As String, _
                                     Optional sysRootCSLID As enum_ShellSpecialFolder, _
                                     Optional customRootPath As String, _
                                     Optional SelectCustomFolderPath As String, _
                                     Optional SelectSysFolderCSIDL As enum_ShellSpecialFolder, _
                                     Optional uFlags As ShellBrowseFlags, _
                                     Optional InvalidSelectionMSG As String, _
                                     Optional InvalidSelectionTitle As String) As String

    Dim typBrowseInfo As BROWSEINFO
    Dim folderPIDL As Long
    Dim strBuff As String

    strSelectCustomFolderPath = SelectCustomFolderPath
    strInvalidSelectionMsg = InvalidSelectionMSG
    strInvalidSelectionTitle = InvalidSelectionTitle
    
    If customRootPath <> "" Then
        folderPIDL = getPIDLfromPath(customRootPath)
    ElseIf sysRootCSLID <> 0 Then
        SHGetSpecialFolderLocation hWnd, sysRootCSLID, folderPIDL
    End If
  
    With typBrowseInfo
        .hWndOwner = hWnd
        .pidlRoot = folderPIDL
        .ulFlags = uFlags
        .lpszTitle = Title
        .lpfn = FnPtrToLong(AddressOf BrowseCallbackProc)
        .pszDisplayName = Space$(MAX_PATH)
    End With
  
    Call CoInitialize(0)
    
    folderPIDL = SHBrowseForFolder(typBrowseInfo)
    
    If Left$(typBrowseInfo.pszDisplayName, 1) <> " " Then
        returnedFolderName = typBrowseInfo.pszDisplayName
        returnedFolderName = Left$(returnedFolderName, InStr(returnedFolderName, vbNullChar) - 1)
    End If
  
    If (folderPIDL) Then
        strBuff = Space$(MAX_PATH)
        Call SHGetPathFromIDList(folderPIDL, strBuff)
        strBuff = Left$(strBuff, InStr(strBuff, vbNullChar) - 1)
    
        Call CoTaskMemFree(folderPIDL)
        
        ShellBrowseForFolder = strBuff
    Else
        ShellBrowseForFolder = ""
    End If

End Function
Public Function LB_GetIndexUnderMouse(LB As Object, _
                                      ByVal Button As Integer, _
                                      ByVal Shift As Integer, _
                                      ByVal X As Single, _
                                      ByVal Y As Single) _
                                            As Long
    Dim Index As Long, lX As Long, lY As Long, Param As Long
    
    On Local Error GoTo Quit
    
    lX = LB.Parent.ScaleX(X, vbTwips, vbPixels)
    lY = LB.Parent.ScaleY(Y, vbTwips, vbPixels)
    
    Param = CLng(lX) + &H10000 * CLng(lY)

    Index = SendMessage(LB.hWnd, LB_ITEMFROMPOINT, 0, ByVal Param)

    If Index > LB.ListCount Then Index = -1
    
    LB_GetIndexUnderMouse = Index
    
Quit:
End Function
Public Function Get_Class(ByVal hWnd As Long) As String
    Dim Buffer As String
    Dim GetClas As Long
    
    Buffer = Space(250)
    GetClas = GetClassName(hWnd, Buffer, 250)
    Get_Class = Left$(Buffer, GetClas)
    
End Function
Public Function isWindowsNT() As Boolean
    Dim OSInfo As OSVERSIONINFO

    With OSInfo
        .dwOSVersionInfoSize = Len(OSInfo)
        GetVersionEx OSInfo
        isWindowsNT = (.dwPlatformId = VER_PLATFORM_WIN32_NT)
    End With
  
End Function
Private Function StrZToStr(S As String) As String
    StrZToStr = Left$(S, Len(S) - 1)
    StrZToStr = Replace(StrZToStr, Chr$(0), "")
End Function
Public Function ArrAdd(TargetArray As Variant, ByVal Value As Variant, _
                       AddTo As arADDTO, Optional Index As Long = -1) As Long
            
    ArrAdd = AddArray(TargetArray, Value, AddTo, Index)

End Function
Public Function Get_WinVer() As oS
    Dim udtOS As OSVERSIONINFO

    udtOS.dwOSVersionInfoSize = Len(udtOS)

    Call GetVersionEx(udtOS)

    Select Case udtOS.dwPlatformId
        Case VER_PLATFORM_WIN32_NT
            If udtOS.dwMajorVersion = 3 Then
                Get_WinVer = osWindowsNT35x
        ElseIf udtOS.dwMajorVersion = 4 Then
            Get_WinVer = osWindowsNT40
        ElseIf udtOS.dwMajorVersion = 5 Then
            If udtOS.dwMinorVersion = 0 Then
                Get_WinVer = osWindows2000
            ElseIf udtOS.dwMinorVersion = 1 Then
                Get_WinVer = osWindowsXP
            ElseIf udtOS.dwMinorVersion = 2 Then
                Get_WinVer = osWindows2003
            End If
        End If
    Case VER_PLATFORM_WIN32_WINDOWS
        If udtOS.dwMinorVersion = 0 Then
             Get_WinVer = osWindows95
        ElseIf udtOS.dwMinorVersion = 10 Then
             Get_WinVer = osWindows98
        ElseIf udtOS.dwMinorVersion = 90 Then
            Get_WinVer = osWindowsMillenium
        End If
    Case VER_PLATFORM_WIN32s
        Get_WinVer = osWindows32s
    Case Else
        Get_WinVer = osUNKNOWN
    End Select

End Function
Private Function FnPtrToLong(ByVal lngFnPtr As Long) As Long
    FnPtrToLong = lngFnPtr
End Function
Private Function getPIDLfromPath(ByVal sPath As String) As Long
    
    getPIDLfromPath = ILCreateFromPath(sPath)
    
    If getPIDLfromPath = 0 Then
        sPath = StrConv(sPath, vbUnicode)
        getPIDLfromPath = ILCreateFromPath(sPath)
    End If

End Function
Private Function BrowseCallbackProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal lParam As Long, ByVal wParam As Long) As Long
    Dim strBuff As String
 
    Select Case uMsg
        Case Is = BFFM_INITIALIZED
                If strSelectCustomFolderPath <> "" Then
                    Call SendMessage(hWnd, BFFM_SETSELECTIONA, 1, strSelectCustomFolderPath)
                Else
                    strBuff = ShellGetSystemFolderPath(0, hWnd)
                    Call SendMessage(hWnd, BFFM_SETSELECTIONA, 1, strBuff)
                End If
        Case Is = BFFM_SELCHANGED
                strBuff = Space$(MAX_PATH)
            
                If SHGetPathFromIDList(lParam, strBuff) Then Call SendMessage(hWnd, BFFM_SETSTATUSTEXTA, 0&, strBuff)                     '<--//*  set the Statustext to Folders Path
        Case Is = BFFM_VALIDATEFAILEDA
                If strInvalidSelectionMsg <> "" Then VBA.MsgBox strInvalidSelectionMsg, , strInvalidSelectionTitle
    End Select
    
    BrowseCallbackProc = 0

End Function
Private Function ShellGetSystemFolderPath(CSIDL As enum_ShellSpecialFolder, Optional hWndOwner As Long) As String
    Dim strBuff As String
    Dim pPIDL As Long
  
    Call SHGetSpecialFolderLocation(hWndOwner, CSIDL, pPIDL)
    strBuff = Space$(MAX_PATH)
    Call SHGetPathFromIDList(pPIDL, strBuff)
    ShellGetSystemFolderPath = Left$(strBuff, InStr(strBuff, Chr$(0)) - 1)

End Function
Public Function ArrAddFromLBCB(LBCB As Object, sArray As Variant) As Long
    Dim P As Long
    Dim A() As String
    
    On Local Error GoTo Quit
    
    ReDim A(LBCB.ListCount - 1)
    
    For P = 0 To LBCB.ListCount - 1
        A(P) = LBCB.List(P)
    Next P
    
    sArray = A
    
Quit:
    ArrAddFromLBCB = Err.Number
    
    If Err.Number <> 0 Then Erase A: _
                            sArray = A
    
End Function
Public Function TextBox_AllowAlphaOnly(TextBox As Object, _
                                       tbEvent As tbEVENTnfo, _
                                       Optional KeyCode As Integer, _
                                       Optional LAlpha As Boolean = True, _
                                       Optional UAlpha As Boolean = True, _
                                       Optional Space As Boolean = True, _
                                       Optional HelpOnF1 As Boolean = True, _
                                       Optional SetToolTip As Boolean = True) As Boolean
    Dim S$, T As String, H As String, R$
    Dim P As Long
    
    On Local Error GoTo Quit
    
    TextBox_AllowAlphaOnly = True
    
    If SetToolTip Then _
        H = "In diesem Eingabefeld sind nur Alphanumerische Eingaben zulssig." & _
            IIf(HelpOnF1, " (F1 fr Hilfe)", ""): _
            TextBox.ToolTipText = H

    T = TextBox.Text
        
    If LAlpha Then R$ = lABC
    If UAlpha Then R$ = R$ & uABC
    If Space Then R$ = R$ & Chr$(32)

    Select Case tbEvent
        Case tbCHANGE
            For P = 1 To Len(T)
                If InStr(R$, Mid$(T, P, 1)) > 0 Then _
                    S$ = S$ & Mid$(T, P, 1)
            Next P
            
            If T <> S$ Then TextBox.Text = S$: _
                            TextBox.SelStart = Len(S$): _
                            TextBox.SelLength = 0
        Case tbKEYDOWN
            If KeyCode = 46 Or KeyCode = 8 Or _
               KeyCode = 13 Or KeyCode = 37 Or _
               KeyCode = 38 Or KeyCode = 39 Or _
               KeyCode = 40 Then Exit Function
            
            If KeyCode = 27 Then TextBox.Text = "": _
                                 Exit Function
               
            If HelpOnF1 And KeyCode = 112 Then
                T = "Eingabefeld Hilfe"
                H = "In diesem Eingabefeld sind nur Alphanumerische Eingaben zulssig." & vbCrLf & vbCrLf & _
                    "Folgende Zeichen sind erlaubt:" & vbCrLf & _
                    vbCrLf & R$ & vbCrLf
                    
                If Space Then H = H & "Sowie Freizeichen" & vbCrLf
                
                H = H & vbCrLf & "ESC lscht das Eingabefeld." & vbCrLf
                
                VBA.MsgBox H, vbInformation + vbOKOnly, T
                
                Exit Function
            End If

            If InStr(R$, Chr$(KeyCode)) = 0 Then KeyCode = 0
    End Select
    
    Exit Function
    
Quit:
    TextBox_AllowAlphaOnly = False

End Function
Public Function Get_AllHwnd() As Long()
    Dim L() As Long
    
    L = EnumAll
    Get_AllHwnd = L
    
End Function
Public Function EnumAll() As Long()
    
    Call EnumTask
    EnumAll = tTask

End Function
Public Function EnumTask() As Long()
    
    Erase tTask
    ttCount = 0
    
    Call EnumWindows(AddressOf WndEnumProc, CLng(1))
    
    EnumTask = tTask

End Function
Private Function WndEnumProc(ByVal hWnd As Long, ByVal lParam As Long) As Long
        
    ReDim Preserve tTask(ttCount)
    tTask(ttCount) = hWnd
        
    ttCount = ttCount + 1
    
    WndEnumProc = 1
            
End Function
Public Function isWindowVisible(ByVal hWnd As Long) As Boolean
    isWindowVisible = IsWindowVisibleA(hWnd)
End Function
Public Function wGet_Text(ByVal hWnd As Long) As String
    Dim GetTrim As Long
    Dim TrimSpace As String, GetString As String
    
    GetTrim = SendMessageByNum(hWnd, WM_GETTEXTLENGTH, 0&, 0&)
    TrimSpace = Space$(GetTrim)
    GetString = SendMessageByString(hWnd, WM_GETTEXT, _
                                    GetTrim + 1, TrimSpace)
    
    wGet_Text = TrimSpace
        
End Function
Public Function Get_TaskID(ByVal hWnd As Long) As Long
    Call GetWindowThreadProcessId(hWnd, Get_TaskID)
End Function
Public Function Mouse_isCursorOverControl(Control As Object) As Boolean
    Dim P1 As POINTAPI, P2 As POINTAPI, Cur As POINTAPI
    
    On Local Error GoTo Quit

    With Control.Parent
        P1.X = .ScaleX(Control.Left, .ScaleMode, vbPixels)
        P1.Y = .ScaleY(Control.Top, .ScaleMode, vbPixels)
        
        Call ClientToScreen(.hWnd, P1)
    
        P2.X = .ScaleX(Control.Left + Control.Width, .ScaleMode, vbPixels)
        P2.Y = .ScaleY(Control.Top + Control.Height, .ScaleMode, vbPixels)
    
        Call ClientToScreen(.hWnd, P2)
    End With
    
    Call GetCursorPos(Cur)
    
    If (Cur.X >= P1.X And Cur.X <= P2.X) And (Cur.Y >= P1.Y And Cur.Y <= P2.Y) Then Mouse_isCursorOverControl = True
       
    
Quit:
    Err.Clear
    
End Function
Public Function StayOnTop(ByVal hWnd As Long, _
                          Optional RemoveFromTop As Boolean = False) _
                                As Boolean
    Dim hWndInsertAfter As Long
    
    hWndInsertAfter = IIf(RemoveFromTop, HWND_NOTOPMOST, _
                                         HWND_TOPMOST)
    
    If SetWindowPos(hWnd, hWndInsertAfter, 0, 0, 0, 0, _
                    SWP_NOSIZE Or SWP_NOMOVE) Then _
                        StayOnTop = True
    
End Function
Public Function Get_RandomizedColor() As Long
    Dim R As Integer, g As Integer, B As Integer
        
    R = Get_Randomize(0, 255)
    g = Get_Randomize(0, 255)
    B = Get_Randomize(0, 255)
    
    Get_RandomizedColor = RGB(R, g, B)

End Function
Public Function Get_Randomize(ByVal Min As Long, _
                              ByVal Max As Long) As Long
    Randomize
    Get_Randomize = Rnd * (Max - Min) + Min
    
End Function
Public Function Convert_ColorToHTML(ByVal Color As Long) As String
    Dim Shex As String
    
    On Local Error GoTo Quit
    
    Shex = Hex(Color)
    Shex = String(6 - Len(Shex), "0") & Shex
             
    Convert_ColorToHTML = "#" & Right$(Shex, 2) & Mid$(Shex, 3, 2) & Left$(Shex, 2)

Quit:
    Err.Clear
    
End Function

